import type { Document } from 'mongodb';
export declare const QUERY_PROPERTIES: readonly ["filter", "project", "collation", "sort", "skip", "limit", "maxTimeMS"];
export type QueryProperty = typeof QUERY_PROPERTIES[number];
export type FormField<T> = {
    value: T;
    string: string;
    valid: boolean;
};
export type QueryFormFields = {
    filter: FormField<Document>;
    project: FormField<Document>;
    collation: FormField<Document>;
    sort: FormField<Document>;
    skip: FormField<number>;
    limit: FormField<number>;
    maxTimeMS: FormField<number>;
};
export type QueryFormFieldEntries = {
    [field in keyof QueryFormFields]: [field, QueryFormFields[field]];
}[keyof QueryFormFields][];
export type BaseQuery = Partial<{
    [key in keyof QueryFormFields]: QueryFormFields[key]['value'];
}>;
//# sourceMappingURL=query-properties.d.ts.map