type ClearValueArgs = {
    field: string;
};
type SetRangeValueArgs = {
    field: string;
    min?: unknown;
    minInclusive?: boolean;
    max?: unknown;
    maxInclusive?: boolean;
    unsetIfSet?: boolean;
};
type GeoQuery = unknown;
type MergeGeoQueryArgs = GeoQuery;
type SetGeoWithinValueArgs = {
    field: string;
    center: [number, number];
    radius: number;
};
type SetValueArgs = {
    field: string;
    value: unknown;
    unsetIfSet?: boolean;
};
type SetDistinctValueArgs = {
    field: string;
    value: unknown;
};
type ToggleDistinctValueArgs = {
    field: string;
    value: unknown;
};
export declare function clearValue(input: unknown, args: ClearValueArgs): unknown;
export declare function setValue(input: unknown, args: SetValueArgs): unknown;
export declare function setDistinctValues(input: unknown, args: SetDistinctValueArgs): unknown;
export declare function addDistinctValue(input: unknown, args: ToggleDistinctValueArgs): unknown;
export declare function removeDistinctValue(input: unknown, args: ToggleDistinctValueArgs): unknown;
export declare function toggleDistinctValue(input: unknown, args: ToggleDistinctValueArgs): unknown;
export declare function setRangeValues(input: unknown, args: SetRangeValueArgs): unknown;
export declare function mergeGeoQuery(input: unknown, args: MergeGeoQueryArgs): unknown;
export declare function setGeoWithinValue(input: unknown, args: SetGeoWithinValueArgs): unknown;
declare const CHANGE_FNS: {
    clearValue: typeof clearValue;
    setValue: typeof setValue;
    setDistinctValues: typeof setDistinctValues;
    setRangeValues: typeof setRangeValues;
    addDistinctValue: typeof addDistinctValue;
    removeDistinctValue: typeof removeDistinctValue;
    toggleDistinctValue: typeof toggleDistinctValue;
    mergeGeoQuery: typeof mergeGeoQuery;
    setGeoWithinValue: typeof setGeoWithinValue;
};
export type ChangeFilterEvent = {
    [key in keyof typeof CHANGE_FNS]: {
        type: key;
        payload: typeof CHANGE_FNS[key] extends (_: unknown, args: infer A) => unknown ? A : never;
    };
}[keyof typeof CHANGE_FNS];
export declare function changeFilter<FilterName extends keyof typeof CHANGE_FNS>(name: FilterName, ...args: Parameters<typeof CHANGE_FNS[FilterName]>): unknown;
export {};
//# sourceMappingURL=change-filter.d.ts.map