import type AppRegistry from 'hadron-app-registry';
import type { AnyAction } from 'redux';
import type { ThunkAction, ThunkDispatch } from 'redux-thunk';
import type { DataService } from 'mongodb-data-service';
import type { BaseQuery } from '../constants/query-properties';
import { FavoriteQueryStorage, RecentQueryStorage } from '@mongodb-js/my-queries-storage';
import { AtlasService } from '@mongodb-js/atlas-service/renderer';
type QueryBarDataService = Pick<DataService, 'sample' | 'getConnectionString'>;
export type QueryBarStoreOptions = {
    serverVersion: string;
    globalAppRegistry: AppRegistry;
    localAppRegistry: AppRegistry;
    query: BaseQuery;
    namespace: string;
    dataProvider: {
        dataProvider?: QueryBarDataService;
    };
    atlasService: AtlasService;
    basepath?: string;
    favoriteQueryStorage?: FavoriteQueryStorage;
    recentQueryStorage?: RecentQueryStorage;
};
export declare const rootQueryBarReducer: import("redux").Reducer<import("redux").CombinedState<{
    queryBar: {
        fields: import("../constants/query-properties").QueryFormFields;
        expanded: boolean;
        serverVersion: string;
        schemaFields: unknown[];
        lastAppliedQuery: Partial<{
            filter: import("bson").Document;
            project: import("bson").Document;
            collation: import("bson").Document;
            sort: import("bson").Document;
            skip: number;
            limit: number;
            maxTimeMS: number;
        }> | null;
        applyId: number;
        namespace: string;
        host?: string | undefined;
        recentQueries: {
            _id: string;
            _lastExecuted: Date;
            _ns: string;
            _host?: string | undefined;
            filter?: any;
            project?: any;
            collation?: any;
            sort?: any;
            skip?: number | undefined;
            limit?: number | undefined;
        }[];
        favoriteQueries: {
            _id: string;
            _lastExecuted: Date;
            _ns: string;
            _name: string;
            _dateSaved: Date;
            _dateModified?: Date | undefined;
            _host?: string | undefined;
            filter?: any;
            project?: any;
            collation?: any;
            sort?: any;
            skip?: number | undefined;
            limit?: number | undefined;
        }[];
    };
    aiQuery: import("./ai-query-reducer").AIQueryState;
}>, AnyAction>;
export type RootState = ReturnType<typeof rootQueryBarReducer>;
export type QueryBarExtraArgs = {
    globalAppRegistry?: AppRegistry;
    localAppRegistry?: AppRegistry;
    favoriteQueryStorage: FavoriteQueryStorage;
    recentQueryStorage: RecentQueryStorage;
    dataService: Pick<QueryBarDataService, 'sample'>;
    atlasService: AtlasService;
};
export type QueryBarThunkDispatch<A extends AnyAction = AnyAction> = ThunkDispatch<RootState, QueryBarExtraArgs, A>;
export type QueryBarThunkAction<R, A extends AnyAction = AnyAction> = ThunkAction<R, RootState, QueryBarExtraArgs, A>;
export declare function configureStore(options?: Partial<QueryBarStoreOptions>): import("redux").Store<import("redux").EmptyObject & {
    queryBar: {
        fields: import("../constants/query-properties").QueryFormFields;
        expanded: boolean;
        serverVersion: string;
        schemaFields: unknown[];
        lastAppliedQuery: Partial<{
            filter: import("bson").Document;
            project: import("bson").Document;
            collation: import("bson").Document;
            sort: import("bson").Document;
            skip: number;
            limit: number;
            maxTimeMS: number;
        }> | null;
        applyId: number;
        namespace: string;
        host?: string | undefined;
        recentQueries: {
            _id: string;
            _lastExecuted: Date;
            _ns: string;
            _host?: string | undefined;
            filter?: any;
            project?: any;
            collation?: any;
            sort?: any;
            skip?: number | undefined;
            limit?: number | undefined;
        }[];
        favoriteQueries: {
            _id: string;
            _lastExecuted: Date;
            _ns: string;
            _name: string;
            _dateSaved: Date;
            _dateModified?: Date | undefined;
            _host?: string | undefined;
            filter?: any;
            project?: any;
            collation?: any;
            sort?: any;
            skip?: number | undefined;
            limit?: number | undefined;
        }[];
    };
    aiQuery: import("./ai-query-reducer").AIQueryState;
}, AnyAction> & {
    dispatch: ThunkDispatch<any, {
        dataService: QueryBarDataService | {
            sample: () => Promise<never[]>;
        };
        localAppRegistry: AppRegistry | undefined;
        globalAppRegistry: AppRegistry | undefined;
        recentQueryStorage: RecentQueryStorage;
        favoriteQueryStorage: FavoriteQueryStorage;
        atlasService: AtlasService;
    }, AnyAction>;
} & {
    getCurrentQuery(): unknown;
};
export default configureStore;
//# sourceMappingURL=query-bar-store.d.ts.map